//***********************************//
//             ESP32  card           //
//           Curve Simulator         //
//            Processing             //
//***********************************//
//        Christian Couderc          //
//         www.voilec.com            //
//***********************************//
//   211126

// Bug : dayOfWeek Adafruit


import processing.serial.*;    // Importing the serial library to communicate with the Arduino 

Serial myPort;      // Initializing a vairable named 'myPort' for serial communication
String myString = null;    // Data received from the serial port
String[]list ;
int posX0, posY0;
int order;
PImage img;

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//https://stackoverflow.com/questions/35282540/size-function-not-working-in-processing-3-0

void setup ( ) 
{
size (900, 800);     // Size of the serial window : Impossible to use variables here !
colorMode (RGB, 255, 255, 255);
myPort = new Serial(this, Serial.list()[0],  115200); 
delay (100);

myPort.clear();
// Throw out the first reading, in case we started reading in the middle of a string from the sender.
myString = myPort.readStringUntil('\n');
myString = null;
myPort.clear();
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void draw() 
{
while (myPort.available() > 0) 
    {
    myString = myPort.readStringUntil('\n');
    if (myString != null) 
      {
      println(myString);
      list = split(myString, ',');              
      order = int(list[0]);  
      select ();
      }
    }   
     myPort.clear(); 
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void select ()
{
switch (order)
    {       
    case 10:
      background(); // clearScreen
    break;
    
    case 20:
      textSize(); 
    break;  
    
    case 22:
      labelNum (); // Place numeric label : datas[1] is a num
    break;
     
    case 23:
      labelText (); // Place text label : datas[1] is a string
    break;

    case 24:
      placeImage() ; 
    break;   
     
   case 31:
      strokeWeight (); 
   break;   
   
   case 32:
      noStroke (); // direct command
   break;   
   
    case 33:
      noFill (); // Empty form 
   break;   

   case 34:
      fillForm(); 
   break;   
   
   case 40:
      point(); 
   break;   

   case 41:
      segment(); 
   break;   

   case 42:
      rectangle (); 
   break;   
   
  case 50:
      circle(); 
   break; 
   
   case 51:
      triangle(); 
   break; 
     
   case 54:
      tranSlate (); // Angle received in degres
   break; 
   
   case 55:
      rotateDeg(); // Angle received in degres
   break; 
   
   case 60:
     colorTextFrames(); 
   break;   
   
   case 61:
      colorLines (); 
   break;   
      
   default:
      error(); 
   break;       
  }
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void  labelText() // Write string label   
{
String label = list[1];  
int posX = int(list[2]);  
int posY = int(list[3]); 
text(label, posX, posY);
}
 
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void  placeImage() // 
{
String label = list[1];  
int posX = int(list[2]);  
int posY = int(list[3]); 
int xSize = int(list[4]);  
int ySize = int(list[5]); 
img = loadImage (label);
size(xSize, ySize);
image(img, posX, posY);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void labelNum()      
{
int datas  = int (list[1]); 
int posX = int (list[2]); 
int posY = int (list[3]); 
text(datas, posX, posY); 
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void background()
{
int red  = int (list[1]); 
int green = int (list[2]); 
int blue = int (list[3]); 
background(red, green, blue);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void textSize()
{
int fontSize  = int (list[1]); 
textSize(fontSize);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++


void colorTextFrames() // fill shapes  and color text
{
int red  = int (list[1]); 
int green = int (list[2]); 
int blue = int (list[3]); 
fill (red, green, blue);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void rectangle()
       
{
int XcornerUL = int (list[1]); 
int YcornerUL = int (list[2]); 
int widthRec = int (list[3]); 
int heightRec = int (list[4]); 
rect(XcornerUL, YcornerUL, widthRec, heightRec); 
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void colorLines() 
{
int red  = int (list[1]); 
int green = int (list[2]); 
int blue = int (list[3]); 
stroke (red, green, blue);
} 
   
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void strokeWeight ()
{
int widthOfStroke = int (list[1]);
strokeWeight (widthOfStroke );
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void fillForm() 
{
int red  = int (list[1]); 
int green = int (list[2]); 
int blue = int (list[3]); 
fill (red, green, blue);
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void point ()
{
int posX0 = int (list[1]); 
int posY0 = int (list[2]); 
point (posX0, posY0);
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void segment()
{
int posX0 = int (list[1]); 
int posY0 = int (list[2]); 
int posX1 = int (list[3]); 
int posY1 = int (list[4]); 
line (posX0, posY0, posX1, posY1);
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void circle()
{
int posX0 = int (list[1]); 
int posY0 = int (list[2]); 
int ray = int (list[3]); // No need for float
circle  (posX0, posY0, ray);
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void triangle()
{
int posX0 = int (list[1]); 
int posY0 = int (list[2]); 
int posX1 = int (list[3]); 
int posY1 = int (list[4]); 
int posX2 = int (list[5]); 
int posY2 = int (list[6]); 
triangle  (posX0, posY0, posX1, posY1, posX2, posY2);
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void tranSlate()
{
int posX0 = int (list[1]); // No need for float
int posY0 = int (list[2]); 
translate  (posX0, posY0);
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void rotateDeg()
{
int degres= int (list[1]); 
rotate  (radians (degres)) ; // = degres * PI /180);
} 

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*void clearScreen()
{
int red  = int (list[1]); 
int green = int (list[2]); 
int blue = int (list[3]); 
background (red, green, blue);
} */

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void error()
{
/*textSize(48);
fill (255, 0 , 0);
text("error :", 370, 400); 
text(order, 400, 440); */
} 
 
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void mousePressed () 
{
int mark=0 ;
  if ( mouseButton  ==  LEFT )   
      {
      mark=1 ; 
      }
else if ( mouseButton == RIGHT )  
      {
      mark=2 ; 
      }

  String click   = nf(mark, 2);
  String xMouse  = nf(mouseX, 4);
  String yMouse  = nf(mouseY, 4);
  String mouseOutput = (click + ',' + xMouse + ',' + yMouse);
  //println (mouseOutput); // Only for debug with a delay
  // delay (5000);
  myPort.write (mouseOutput);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
